function vexalarm.initialize.core(reload)
	RegisterAddonMessagePrefix("VEXALARM_SP")
	RegisterAddonMessagePrefix("VEXALARM_SP_RE")
	
	vexalarm.initialize.loadSV(false)
	vexalarm.frames.create()
	vexalarm.warning.checkShow()
	
	--vexalarm.testmode.notAniFuncs()
	
	if not(reload) then
		vexalarm_optionpanel = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm", "Vex Alarm")
		vexalarm_optionpanel_frame_manager = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Frame: Settings", "Frame: Settings", "Vex Alarm")
		vexalarm_optionpanel_frame_content = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Frame: Spells to check", "Frame: Spells to check", "Vex Alarm")
		vexalarm_optionpanel_msgcontent = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Frame: Messages", "Frame: Messages", "Vex Alarm")
		vexalarm_optionpanel_rw = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Raid Warning: Settings", "RW: Settings" , "Vex Alarm")
		vexalarm_optionpanel_frame_content = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Raid Warning: Spells to check", "RW: Spells to check", "Vex Alarm")
		vexalarm_optionpanel_rwmsgcontent = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Raid Warning: Messages", "RW: Messages" , "Vex Alarm")
		vexalarm_optionpanel_spells = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Spells: Settings", "Spells: Settings", "Vex Alarm")
		vexalarm_optionpanel_spellprofiles = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Spells: Profiles", "Spells: Profiles", "Vex Alarm")
		vexalarm_optionpanel_profiles = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Addon: Profiles", "Addon: Profiles" , "Vex Alarm")
		vexalarm_optionpanel_profiles = vexalarm.AceConfigDialog:AddToBlizOptions("Vex Alarm Addon: Defaults", "Addon: Defaults" , "Vex Alarm")
	end
	
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm", vexalarm.options.main.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Frame: Settings", vexalarm.options.frame.settings.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Frame: Spells to check", vexalarm.options.frame.content.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Frame: Messages", vexalarm.options.frame.messages.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Raid Warning: Settings", vexalarm.options.rw.settings.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Raid Warning: Spells to check", vexalarm.options.rw.content.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Raid Warning: Messages", vexalarm.options.rw.messages.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Spells: Settings", vexalarm.options.spells.settings.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Spells: Profiles", vexalarm.options.spells.profiles.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Addon: Profiles", vexalarm.options.profiles.panel(), {})
	vexalarm.AceConfig:RegisterOptionsTable("Vex Alarm Addon: Defaults", vexalarm.options.globals.panel(), {})
	
	
	
	vexalarm.inRaid = UnitInRaid("player")
	
	if not(reload) then 
		for i=1,40 do
			if i<10 then	k = "0"..i
			else			k = ""..i end
			vexalarm.LSM:Register("sound", k, "Interface\\AddOns\\vexalarm\\sounds\\button_"..i..".ogg")
		end
		vexalarm.LSM:Register("border", "Solid", "Interface\\Buttons\\WHITE8X8")
		vexalarm.LSM:Register("font", "Emblem", "Interface\\AddOns\\vexalarm\\fonts\\EMBLEM.tff")
		
	vexalarm.scanTool.frame = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" )
	vexalarm.scanTool.frame:SetOwner( WorldFrame, "ANCHOR_NONE" )
	vexalarm.scanTool.text = _G["ScanTooltipTextLeft2"]
	end
	
end


function vexalarm.initialize.loadSV(defaults)	
	if vexalarm_SV_spellprofiles == nil then vexalarm_SV_spellprofiles = {} end
	if vexalarm_SV_profiles == nil then vexalarm_SV_profiles = {} end
	
	if vexalarm_SV_general == nil and vexalarm_SV_profiles ~= nil and vexalarm_SV_default ~= nil then
		if vexalarm_SV_default["activate"] then
			if vexalarm_SV_profiles[vexalarm_SV_default["profile"]] ~= nil then
				vexalarm.options.profiles.current = vexalarm_SV_default["profile"]
				vexalarm.options.profiles.load("all", true)
			else
				print("|CFFFF7D0AVex Alarm|r ERROR: Could not load default profile. Default profile '"..vexalarm_SV_default["profile"].."' doesn't exist.")
				print("|CFFFF7D0AVex Alarm|r ERROR: Default addon settings will loaded instead. You can still load another profile manually in the options")
			end
		end
	end
	
	vexalarm_SV_default = vexalarm.initialize.checkTableData(vexalarm.defaults.global, vexalarm_SV_default, defaults)
	vexalarm_SV_general = vexalarm.initialize.checkTableData(vexalarm.defaults.general, vexalarm_SV_general, defaults)
	vexalarm_SV_rw = vexalarm.initialize.checkTableData(vexalarm.defaults.rw, vexalarm_SV_rw, defaults)
	vexalarm_SV_frame = vexalarm.initialize.checkData(vexalarm.defaults.frame["Mainframe"], vexalarm_SV_frame, defaults)
	vexalarm_SV_spells = vexalarm.initialize.checkTableData(vexalarm.defaults.spells, vexalarm_SV_spells, defaults)
	
	for key in pairs(vexalarm_SV_spellprofiles) do
		vexalarm_SV_spellprofiles[key] = vexalarm.initialize.checkTableData(vexalarm.defaults.spells, vexalarm_SV_spellprofiles[key], defaults)
	end
	
	if defaults then vexalarm.initialize.core(true) end
end

function vexalarm.initialize.checkData(defaults, saved, force)
	local temp = {}
	if force or saved == nil or type(saved) ~= "table" then
		temp = vexalarm.lib.copyTable(vexalarm.defaults.frame)
	else
		for key,val in pairs(saved) do
			temp[key] = vexalarm.initialize.checkTableData(defaults, val, force)
		end
	end
	return temp
end

function vexalarm.initialize.checkTableData(defaults, saved, force)
	local temp = {}
	if force or type(saved) ~= "table" then temp=defaults
	else
		for key,val in pairs(defaults) do
			if type(val) == "table" then
				temp[key] = {}
				if saved[key] == nil then
					temp[key] = val
				else
					temp[key] = vexalarm.initialize.checkTableData(defaults[key], saved[key], force)
				end
			else
				if saved[key] == nil then
					temp[key] = val
				else
					temp[key] = saved[key]
				end
			end
		end
	end
	return temp
end