function vexalarm.warning.handler(spellname, spellid, caster, target, status, eventchar, guid)
	for key in pairs(vexalarm.frames.createdFrames) do
		vexalarm.warning.checkWarnings(key)
		
		if vexalarm.warning.checkOwnSpell(caster, key) and vexalarm.warning.checkOwnGrp(caster, key) and vexalarm.warning.checkInfight(key) then
		
			if string.find(guid, "Pet")~=nil then
				caster = vexalarm.warning.getOwnerOfPet(caster)
			end
			local alarmtype = vexalarm.warning.validate(spellid, caster, eventchar, key)
			if(alarmtype ~="" and alarmtype ~="dejavue") then
				vexalarm.warning.postWarning(alarmtype, spellname, spellid, caster, target, status, key)				
			end
		end
	end
end

function vexalarm.warning.validate(auraID, player, eventchar, frame, rw)
	local returnvalue = ""
	
	local auraID=tostring(auraID)

	--overflow check - check data
	local currenttime = time()
	local eventstring = ""
	if eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_RESURRECT" then eventstring = "gain"
	else eventstring = "lost" end
	local spelltype = ""
	
	if vexalarm.defaults.spells[auraID]~=nil then
		local spellaccept = false
		if rw then
			if vexalarm_SV_rw["spellsToCheck"]["useSpellProfile"] then
				local rw_sp = vexalarm_SV_rw["spellsToCheck"]["spellProfile"]
				if vexalarm_SV_spellprofiles[rw_sp] ~= nil then
					spelldata = vexalarm_SV_spellprofiles[rw_sp]
					if spelldata[auraID] ~= nil then
						spellaccept = spelldata[auraID][vexalarm.warning.getPlayerRole(player)]
						spelltype = spelldata[auraID][6]
					end
				end
			else
				spellaccept = vexalarm_SV_spells[auraID][vexalarm.warning.getPlayerRole(player)]
				spelltype = vexalarm_SV_spells[auraID][6]
			end
		else
			if vexalarm_SV_frame[frame]["spellsToCheck"]["useSpellProfile"] then
				local rw_sp = vexalarm_SV_frame[frame]["spellsToCheck"]["spellProfile"]
				if vexalarm_SV_spellprofiles[rw_sp] ~= nil then
					spelldata = vexalarm_SV_spellprofiles[rw_sp]
					if spelldata[auraID] ~= nil then
						spellaccept = spelldata[auraID][vexalarm.warning.getPlayerRole(player)]
						spelltype = spelldata[auraID][6]
					end
				end
			else
				spellaccept = vexalarm_SV_spells[auraID][vexalarm.warning.getPlayerRole(player)]
				spelltype = vexalarm_SV_spells[auraID][6]
			end
		end
		
		if spellaccept then
			local totem = vexalarm.defaults.spells[auraID][7]
						
			local eventaccept = false
			if ((eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_AURA_REMOVED" or (eventchar == "SPELL_SUMMON" and totem)) and (spelltype == "buffWOtarget" or spelltype == "buffWtarget")) or
				((eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT") and (spelltype == "castWtarget" or spelltype == "castWOtarget"))	then
					eventaccept = true
			end
			
			if spellaccept and eventaccept then
				returnvalue = spelltype
			end
		
			--OVERFLOWCHECK
			-- if vexalarm.defaults.spells[auraID][8] and returnvalue~="" then
			if returnvalue~="" then
				if rw then
					local delete = {}
					for i in pairs(vexalarm.lastSpellRW) do
						local v=vexalarm.lastSpellRW[i]
						if v[2]+2<=currenttime then
							delete[#delete+1]=i
						elseif v[1]==auraID and v[3]==eventstring and v[4]==player then
							returnvalue="dejavue"
						end
					end
					
					local deleted= 0
					for i in pairs(delete) do
						vexalarm.lastSpellRW[i-deleted]=nil
						deleted=deleted+1
					end
					if returnvalue~="dejavue" then
						vexalarm.lastSpellRW[#vexalarm.lastSpellRW+1] = {auraID, currenttime, eventstring, player}
					end
				else
					local delete = {}
					for i in pairs(vexalarm.lastSpell) do
						local v=vexalarm.lastSpell[i]
						if v[2]+2<=currenttime then
							delete[#delete+1]=i
						elseif v[1]==auraID and v[3]==eventstring and v[4]==player and v[5]==frame then
							returnvalue="dejavue"
						end
					end
					
					local deleted= 0
					for i in pairs(delete) do
						vexalarm.lastSpell[i-deleted]=nil
						deleted=deleted+1
					end
					if returnvalue~="dejavue" then
						vexalarm.lastSpell[#vexalarm.lastSpell+1] = {auraID, currenttime, eventstring, player, frame}
					end
				end
			end
		end
	end
	return returnvalue
end

function vexalarm.warning.checkWarnings(frame)
	local currenttime = time()
	
	-- check and remove old proclaims
	local removes = 0
	if #vexalarm.proclaims[frame] ~= 0 then
		for i=1, #vexalarm.proclaims[frame] do
			local k=i-removes
			if vexalarm.proclaims[frame][k][1]+vexalarm_SV_frame[frame]["fadeOutEffect"]["durationShow"]+vexalarm_SV_frame[frame]["fadeOutEffect"]["durationVanish"]+0.2 <= currenttime then
				vexalarm.proclaims[frame][k][2][1]:Hide()
				local place = vexalarm.proclaims[frame][k][3]
				vexalarm.proclaimPlaces[frame][place] = false
				table.remove(vexalarm.proclaims[frame], k)
				removes = removes + 1
			end
		end
	end

	-- sort current proclaims
	if vexalarm_SV_frame[frame]["design"]["scrolling"]["enable"] and #vexalarm.proclaims[frame] ~= 0 then
		for i=1, #vexalarm.proclaims[frame] do
			vexalarm.proclaimPlaces[frame][vexalarm.proclaims[frame][i][3]] = false
			vexalarm.proclaimPlaces[frame][i]=true
			vexalarm.proclaims[frame][i][3] = i
			if vexalarm_SV_frame[frame]["design"]["scrolling"]["downwards"] then
				vexalarm.proclaims[frame][i][2][2]:SetPoint("BOTTOMLEFT", vexalarm.frames.createdFrames[frame], "BOTTOMLEFT",
											vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["x"],
											(vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["spacing"]*i)-vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["y"])

			else
				vexalarm.proclaims[frame][i][2][2]:SetPoint("TOPLEFT", vexalarm.frames.createdFrames[frame], "TOPLEFT",
											vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["x"],
											(-vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["spacing"]*i)+vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["y"])
			end
		end
	end
end

function vexalarm.warning.generateWarning(alarmtype, spell, spellid, caster, target, status, msg, frame)
	local statusstring = ""
	if status then
		statusstring = "active"
	else
		statusstring = "inactive"
	end
	
	local newframe = CreateFrame("Frame", nil, vexalarm.frames.createdFrames[frame])
	newframe:Show()
	local fontstring = newframe:CreateFontString("frame", "ARTWORK", "GameFontNormal")
	
	--remove oldest proclaims when too many proclaims
	if #vexalarm.proclaims[frame] >= vexalarm_SV_frame[frame]["design"]["maxEvents"] then
		vexalarm.proclaims[frame][1][2][1]:Hide()
		vexalarm.proclaimPlaces[frame][vexalarm.proclaims[frame][1][3]] = false
		table.remove(vexalarm.proclaims[frame], 1)
	end
	local position = 0
	for i=1, #vexalarm.proclaimPlaces[frame]+1 do
		if not(vexalarm.proclaimPlaces[frame][i]) and position == 0 then position = i end
	end
	vexalarm.proclaimPlaces[frame][position] = true
	
	if vexalarm_SV_frame[frame]["design"]["scrolling"]["downwards"] then
		fontstring:SetPoint("BOTTOMLEFT", vexalarm.frames.createdFrames[frame], "BOTTOMLEFT",
									vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["x"],
									(vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["spacing"]*position)-vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["y"])

	else
		fontstring:SetPoint("TOPLEFT", vexalarm.frames.createdFrames[frame], "TOPLEFT",
									vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["x"],
									(-vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["spacing"]*position)+vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["y"])
	end		
			
			
	fontstring:SetText(msg)
	fontstring:SetTextColor(vexalarm_SV_frame[frame]["design"]["text"]["color"][statusstring]["r"],
						vexalarm_SV_frame[frame]["design"]["text"]["color"][statusstring]["g"],
						vexalarm_SV_frame[frame]["design"]["text"]["color"][statusstring]["b"],
						vexalarm_SV_frame[frame]["design"]["text"]["color"][statusstring]["a"])
	fontstring:SetFont(vexalarm.LSM:Fetch("font", vexalarm_SV_frame[frame]["design"]["text"]["font"]),
				vexalarm_SV_frame[frame]["design"]["text"]["size"],
				vexalarm_SV_frame[frame]["design"]["text"]["outline"])	
	fontstring:SetJustifyH(vexalarm_SV_frame[frame]["design"]["text"]["align"])
	fontstring:SetWidth(vexalarm_SV_frame[frame]["design"]["size"]["width"]-(vexalarm_SV_frame[frame]["design"]["position"]["warnings"]["x"]*2))
	local newmsgframe_aniGRP = newframe:CreateAnimationGroup("newmsgframe_aniGRP")
	newmsgframe_aniGRP:SetLooping("NONE")
	newmsgframe_ani = newmsgframe_aniGRP:CreateAnimation("Alpha")
	newmsgframe_ani:SetStartDelay(vexalarm_SV_frame[frame]["fadeOutEffect"]["durationShow"])
	newmsgframe_ani:SetOrder(1)
	newmsgframe_ani:SetSmoothing("IN")
		newmsgframe_ani:SetEndDelay(0)
		newmsgframe_aniGRP:SetScript("OnFinished",
			function (self)
				local parentframe = self:GetParent()
				parentframe:Hide()
			end)
		
	if status and vexalarm.defaults.spells[tostring(spellid)][7]~=nil then
		vexalarm.totem.create(alarmtype, spell, spellid, caster, target, frame)
	end
	
	--adding fade-out-effect
	if vexalarm_SV_frame[frame]["fadeOutEffect"]["enable"] then
		newmsgframe_ani:SetDuration(vexalarm_SV_frame[frame]["fadeOutEffect"]["durationVanish"])
		newmsgframe_ani:SetChange(-1)
	else
		newmsgframe_ani:SetDuration(0)
		newmsgframe_ani:SetChange(1)
	end
	newmsgframe_aniGRP:Play()
	
	vexalarm.proclaims[frame][#vexalarm.proclaims[frame]+1] = {time(), {newframe, fontstring, newmsgframe_aniGRP}, position}
end

function vexalarm.warning.generateText(alarmtype, spell, spellid, caster, target, status, frame, fakecolor)
	--load custom msg
	local customalarm = ""
	local statusstring = "inactive"
	if status then statusstring = "active" end
	
	if caster == target and not(vexalarm_SV_general["msgs"]["misc"]["showTargetwhenCaster"]) then
		if alarmtype == "buffWtarget" 			then alarmtype = "buffWOtarget"
		elseif alarmtype == "castWtarget" 	then alarmtype = "castWOtarget"
		end
	end
	
	if 		alarmtype == "buffWtarget" 		then customalarm = vexalarm_SV_general["msgs"]["buffWtarget"][statusstring]
	elseif 	alarmtype == "buffWOtarget"	  	then customalarm = vexalarm_SV_general["msgs"]["buffWOtarget"][statusstring]
	elseif 	alarmtype == "castWtarget" 		then customalarm = vexalarm_SV_general["msgs"]["castWtarget"]
	elseif 	alarmtype == "castWOtarget" 	then customalarm = vexalarm_SV_general["msgs"]["castWOtarget"]
	end
	
	--load custom status msg
	local statustext=vexalarm_SV_general["msgs"]["status"][statusstring]
	
	-- change [spell]
	if fakecolor then
		if spell ~= nil then
			customalarm = string.gsub(customalarm, "%[spell%]", spell.."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[spell_sc%]", vexalarm.colorize.scTags(spell, 3, frame).."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[spell_cc%]", vexalarm.colorize.class(spell, spellid, "spell").."|CFF"..fakecolor)
		end
		if caster ~= nil then
			caster = vexalarm.warning.convertServernames(caster)
			customalarm = string.gsub(customalarm, "%[caster%]", caster.."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[caster_sc%]", vexalarm.colorize.scTags(caster, 1, frame).."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[caster_cc%]", vexalarm.colorize.class(caster, spellid, "caster").."|CFF"..fakecolor)
		end
		if target ~= nil then
			target = vexalarm.warning.convertServernames(target)
			customalarm = string.gsub(customalarm, "%[target%]", target.."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[target_sc%]", vexalarm.colorize.scTags(target, 2, frame).."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[target_cc%]", vexalarm.colorize.class(target, spellid, "target").."|CFF"..fakecolor)
		end
		if statustext ~= nil then
			customalarm = string.gsub(customalarm, "%[status%]", statustext.."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[status_sc%]", vexalarm.colorize.status(statustext, status, frame).."|CFF"..fakecolor)
			customalarm = string.gsub(customalarm, "%[status_cc%]", vexalarm.colorize.status(statustext, status, frame).."|CFF"..fakecolor)
		end
	else
		if spell ~= nil then
			customalarm = string.gsub(customalarm, "%[spell%]", spell)
			customalarm = string.gsub(customalarm, "%[spell_sc%]", vexalarm.colorize.scTags(spell, 3, frame))
			customalarm = string.gsub(customalarm, "%[spell_cc%]", vexalarm.colorize.class(spell, spellid, "spell"))
		end
		if caster ~= nil then
			caster = vexalarm.warning.convertServernames(caster)
			customalarm = string.gsub(customalarm, "%[caster%]", caster)
			customalarm = string.gsub(customalarm, "%[caster_sc%]", vexalarm.colorize.scTags(caster, 1, frame))
			customalarm = string.gsub(customalarm, "%[caster_cc%]", vexalarm.colorize.class(caster, spellid, "caster"))
		end
		if target ~= nil then
			target = vexalarm.warning.convertServernames(target)
			customalarm = string.gsub(customalarm, "%[target%]", target)
			customalarm = string.gsub(customalarm, "%[target_sc%]", vexalarm.colorize.scTags(target, 2, frame))
			customalarm = string.gsub(customalarm, "%[target_cc%]", vexalarm.colorize.class(target, spellid, "target"))
		end
		if statustext ~= nil then
			customalarm = string.gsub(customalarm, "%[status%]", statustext)
			customalarm = string.gsub(customalarm, "%[status_sc%]", vexalarm.colorize.status(statustext, status, frame))
			customalarm = string.gsub(customalarm, "%[status_cc%]", vexalarm.colorize.status(statustext, status, frame))
		end
	end
			
	return customalarm
end

function vexalarm.warning.convertServernames(name)
	if vexalarm_SV_general["msgs"]["misc"]["allowServerName"] then
		return name
	else
		if string.find(name, "%-.-$")~=nil then
			name = string.gsub(name, "%-.-$", "")
		end
		return name
	end
end

function vexalarm.warning.checkShow()
	local show = {}
	for frame in pairs(vexalarm.frames.createdFrames) do
		if vexalarm_SV_general["enableAddon"] then			
			if (not(vexalarm.infight) and vexalarm_SV_frame[frame]["show"]["enableFrameOnlyInfight"]) then
				vexalarm.frames.createdFrames[frame]:Hide()
			else
				vexalarm.frames.createdFrames[frame]:Show()
			end
		else
			vexalarm.frames.createdFrames[frame]:Hide()
		end
	end
end

function vexalarm.warning.checkInfight(frame, rw)
	local returnvalue = true
	
	if rw then
		if vexalarm_SV_rw["activateOnlyInfight"] and not(vexalarm.infight) then
			returnvalue = false
		end
	elseif vexalarm_SV_frame[frame] ~= nil then
		if vexalarm_SV_frame[frame]["show"]["activateCheckOnlyInfight"] and not(vexalarm.infight) then
			returnvalue = false
		end
	end
	
	return returnvalue
end

function vexalarm.warning.getOwnerOfPet(petName)
   vexalarm.scanTool.frame:ClearLines()
   vexalarm.scanTool.frame:SetUnit(petName)
   local ownerText = vexalarm.scanTool.text:GetText()
   if not ownerText then return nil end
   local owner, _ = string.split("'",ownerText)
   
   return owner -- This is the pet's owner
end

function vexalarm.warning.checkOwnSpell(caster, frame)
	local returnvalue = true
	
	local check = vexalarm_SV_frame[frame]["show"]["mySpells"]
	
	if not(check) and caster==select(1, UnitName("player")) then returnvalue = false end	
	return returnvalue
end

function vexalarm.warning.checkOwnGrp(caster, frame, rw)
	local returnvalue = true
	
	local check = ""
	if rw then
		check = true
	else
		check = vexalarm_SV_frame[frame]["show"]["showGrpMembersOnly"]
	end
	
	if not(vexalarm.warning.getGrpData(caster)) and check and caster~=select(1, UnitName("player")) then
		returnvalue = false
	end
	
	return returnvalue
end

function vexalarm.warning.getGrpData(caster)
	local returnvalue = false
	returnvalue = UnitPlayerOrPetInRaid(caster)
	if not(returnvalue) then returnvalue = UnitPlayerOrPetInParty(caster) end
	return returnvalue
end

function vexalarm.warning.getPlayerRole(player)
	local returnvalue = 4
	if player ~= nil then
		local role = UnitGroupRolesAssigned(player)
		if role == "DAMAGER" then
			returnvalue = 3
		elseif role == "HEALER" then
			returnvalue = 2
		elseif role == "TANK" then
			returnvalue = 1
		else
			returnvalue = 4
		end
	end
	return returnvalue
end

function vexalarm.warning.playSound(status, alarmtype, frame)
	if vexalarm_SV_frame[frame]["sounds"]["enable"] and vexalarm.frames.createdFrames[frame]:IsShown() then 
		if alarmtype == "castWtarget" or alarmtype == "castWOtarget" then 
			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_SV_frame[frame]["sounds"]["cast"]["file"]), vexalarm_SV_frame[frame]["sounds"]["cast"]["channel"])
		else
			if status then 	PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_SV_frame[frame]["sounds"]["buffApplied"]["file"]), vexalarm_SV_frame[frame]["sounds"]["buffApplied"]["channel"])
			else 			PlaySoundFile(vexalarm.LSM:Fetch("sound", vexalarm_SV_frame[frame]["sounds"]["buffFade"]["file"]), vexalarm_SV_frame[frame]["sounds"]["buffFade"]["channel"]) end
		end
	end
end

function vexalarm.warning.postWarning(alarmtype, spell, spellid,  caster, target, status, frame)
	local msg = vexalarm.warning.generateText(alarmtype, spell, spellid, caster, target, status, frame)
	if msg~="" then
		vexalarm.warning.generateWarning(alarmtype, spell, spellid, caster, target, status, msg, frame)
		vexalarm.warning.playSound(status, alarmtype, frame)
	end
end